<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="年份" prop="configName">
        <el-date-picker
          v-model="queryParams.year"
          type="year"
          value-format="yyyy"
          placeholder="选择年"
          size="small"
          @keyup.enter.native="handleQuery"
        >
        </el-date-picker>
      </el-form-item>
      <el-form-item label="部门" prop="sysDeptId">
        <el-cascader :options="typeOptionstwo" :props="{value: 'id'}" @change="changeBtn" :show-all-levels="false"></el-cascader>
      <!-- <el-select
         v-model="queryParams.sysDeptId"
         placeholder="请选择部门"
         clearable
         size="small"
       >
         <el-option
           v-for="dict in typeOptionstwo"
           :key="dict.deptId"
           :label="dict.deptName"
           :value="dict.deptId"
         />
       </el-select>-->
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['deptPlan:Plan:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['deptPlan:Plan:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['deptPlan:Plan:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['deptPlan:Plan:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="planList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="年度" align="center" prop="year" />
      <el-table-column label="部门" align="center" prop="deptName" />
      <el-table-column label="当年实际到位资金目标任务(万元)" align="center" prop="targetContractAmount" />
      <el-table-column label="当年新签约金额目标任务(万元)" align="center" prop="targetArrivalAmount" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['deptPlan:Plan:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['deptPlan:Plan:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改 部门招商计划对话框 -->
    <el-dialog :close-on-click-modal="false" :title="title" :visible.sync="open" width="900px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="250px">
        <el-form-item label="年度" prop="year">
          <el-date-picker
            v-model="form.year"
            type="year"
            value-format="yyyy"
            placeholder="选择年"
            style="width: 100%;"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="部门" prop="sysDeptId">
          <el-cascader :options="typeOptionstwo" :props="{value: 'id'}"   v-model="form.sysDeptId" @change="changeBtn1" :show-all-levels="false"></el-cascader>
        </el-form-item>


        <el-form-item label="当年实际到位资金目标任务(万元)" prop="targetContractAmount">
          <el-input v-model="form.targetContractAmount" placeholder="请输入当年实际到位资金目标任务(万元)" />
        </el-form-item>
        <el-form-item label="当年新签约金额目标任务(万元)" prop="targetArrivalAmount">
          <el-input v-model="form.targetArrivalAmount" placeholder="请输入当年新签约金额目标任务(万元)" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listPlan, getPlan, delPlan, addPlan, updatePlan, exportPlan } from "@/api/deptplan/plan";
import {listConfigfieu} from "@/api/system/config";
export default {
  name: "Plan",
  components: {
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      //  部门招商计划表格数据
      planList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      typeOptionstwo:[],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        sysDeptId: null,
        isDel: null,
        year: null,
        targetContractAmount: null,
        targetArrivalAmount: null,
        typeOptionstwo:[]
      },
      // 表单参数
      form: {
        year: new Date()
      },
      // 表单校验
      rules: {
        targetContractAmount:[
                  { required: true, message: '请输入当年实际到位资金目标任务(万元)', trigger: 'change' }
                ],
        targetArrivalAmount:[
                  { required: true, message: '请输入当年新签约金额目标任务(万元)', trigger: 'change' }
                ],
        sysDeptId: [
                    { required: true, message: '请选择部门', trigger: 'change' }
                  ],
        year: [
                    { type: 'string', required: true, message: '请选择年份', trigger: 'change' }
                  ],
      }
    };
  },
  created() {
    this.getList();
    this.getListthuy()
  },
  methods: {
    changeBtn(e){
      if(e.length == 1){
        this.queryParams.sysDeptId  = e.join(',')
      }else{
         this.queryParams.sysDeptId = e[e.length-1]
      }

    },
    changeBtn1(e){
      if(e.length == 1){
        this.form.sysDeptId  = e.join(',')
      }else{
        this.form.sysDeptId = e[e.length-1]
      }

    },
    /** 查询 部门招商计划列表 */
    getList() {
      this.loading = true;
      listPlan(this.queryParams).then(response => {
        this.planList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    //部门列表
    getListthuy() {
      this.loading = true;
      listConfigfieu().then((response) => {
        console.log(response.data)
        this.typeOptionstwo = response.data;
        // this.fileList =  this.queryParams.attachment
        // this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        sysDeptId: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        isDel: null,
        year: null,
        targetContractAmount: null,
        targetArrivalAmount: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加 部门招商计划";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getPlan(id).then(response => {
        this.form = response.data;
        this.form.sysDeptId = this.form.sysDeptId - 0
        // this.form.sysDeptId = response.data.sysDeptId.split(',')
        // console.log( response.data.sysDeptId.length)
        this.open = true;
        this.title = "修改 部门招商计划";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updatePlan(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPlan(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除 部门招商计划编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delPlan(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有 部门招商计划数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportPlan(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    }
  }
};
</script>
